<template>
	<q-page>
		<div class="q-pa-md">
			<div v-if="add" class="q-pa-sm">
				<div class="row">
					<div></div>
					<q-space />
					<div>
						<q-btn
							key="`btn_size_rd_sm`"
							class="bg-blue-6 text-white"
							size="sm"
							label="Create user"
							@click="userCreate(true)"
						/>
					</div>
				</div>
			</div>
			<q-table
				title="User Information"
				:data="data"
				:columns="columns"
				row-key="name"
				ref="table"
			>
				<template v-slot:body="props">
					<q-tr :props="props">
						<q-td key="name" :props="props">
							{{ props.row.USERNAME }}
						</q-td>
						<q-td key="email" :props="props">
							{{ props.row.EMAIL }}
						</q-td>
						<q-td key="age" :props="props">
							{{ props.row.AGE }}
						</q-td>
						<q-td key="birthdate" :props="props">
							{{ props.row.BIRTHDATE }}
						</q-td>
						<q-td key="options" :props="props">
							<div class="q-pa-md">
								<q-btn-dropdown
									color="white"
									text-color="black"
									label="Options"
								>
									<q-list>
										<q-item
											v-if="edit"
											clickable
											@click="
												userEdit({
													userId: props.row.USER_ID,
													userName:
														props.row.USERNAME,
													userEmail: props.row.EMAIL,
													userAge: props.row.AGE,
													userBirthDate:
														props.row.BIRTHDATE,
													editForm: true,
												})
											"
										>
											<q-item-section>
												<q-item-label class="text-green"
													>Edit</q-item-label
												>
											</q-item-section>
										</q-item>
										<q-item
											v-if="del"
											clickable
											@click="
												userDel({
													userId: props.row.USER_ID,
													userName:
														props.row.USERNAME,
													delDialog: true,
												})
											"
										>
											<q-item-section>
												<q-item-label class="text-red"
													>Delete</q-item-label
												>
											</q-item-section>
										</q-item>
										<q-item
											v-if="edit"
											clickable
											@click="
												userChangePwd({
													userId: props.row.USER_ID,
													userName:
														props.row.USERNAME,
													changePwdForm: true,
												})
											"
										>
											<q-item-section>
												<q-item-label
													class="text-orange"
													>Change
													Password</q-item-label
												>
											</q-item-section>
										</q-item>
									</q-list>
								</q-btn-dropdown>
							</div>
						</q-td>
					</q-tr>
				</template>
			</q-table>
		</div>

		<!-- <button @click="refresh">test</button> -->
		<user-edit @reload="getUserData" />
		<user-delete @reload="getUserData" />
		<user-create />
		<user-change-pwd />
	</q-page>
</template>

<script>
import { mapActions } from "vuex";
import { mapGetters } from "vuex";
export default {
	components: {
		"user-edit": require("./user-modals/UserEdit.vue").default,
		"user-delete": require("./user-modals/UserDel.vue").default,
		"user-create": require("./user-modals/UserCreate.vue").default,
		"user-change-pwd": require("./user-modals/UserChangePwd.vue").default,
	},
	data() {
		return {
			add: true,
			edit: true,
			del: true,
			columns: [
				{
					name: "name",
					required: true,
					label: "Username",
					align: "left",
					field: (row) => row.name,
					format: (val) => `${val}`,
					sortable: true,
				},
				{
					name: "email",
					align: "center",
					label: "Email",
					field: "email",
					sortable: true,
				},
				{ name: "age", label: "Age", field: "age", sortable: true },
				{ name: "birthdate", label: "Birthdate", field: "birthdate" },
				{
					name: "options",
					label: "Options",
					align: "center",
					field: "options",
				},
			],

			data: [],
			texts: "null",
		};
	},
	methods: {
		getUserData() {
			this.$axios
				.get(
					this.host +
						"/src/php/actions/user.php?req=user-info-fetch-all",
					{
						withCredentials: true,
					}
				)
				.then((response) => {
					this.data = response.data;
				});
		},

		...mapActions({
			userEdit: "showcase/userEdit",
			userDel: "showcase/userDel",
			userCreate: "showcase/userCreate",
			userChangePwd: "showcase/userChangePwd",
		}),

		refreshTable() {
			this.getUserData();
		},
	},
	watch: {
		// data() {
		// 	this.getUserData();
		// },
	},
	computed: {
		...mapGetters({
			uiAdd: "showcase/uiAdd",
			uiEdit: "showcase/uiEdit",
			uiDelete: "showcase/uiDelete",
			userLevel: "showcase/userLevel",
		}),
	},
	created() {
		this.getUserData();
		if (this.userLevel == "staff") {
			this.add = JSON.parse(this.uiAdd);
			this.edit = JSON.parse(this.uiEdit);
			this.del = JSON.parse(this.uiDelete);
		}
	},
};
</script>
